// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type GetTemplatevDetailReq struct {
	ModelId    int64 `form:"model_id"`
	TemplateId int64 `form:"template_id"`
}

type GetTemplatevDetailRsp struct {
	ProductModelInfo interface{}     `json:"product_model_info"`
	ProductTemplate  ProductTemplate `json:"product_template"`
	LightList        []Light         `json:"light_list"`
	OptionModelInfo  []interface{}   `json:"option_model_info"`
	Tag              int64           `json:"tag"`
}

type Tag struct {
	Id    int64  `json:"id"`
	Title string `json:"title"`
}

type TemplateInfo struct {
	Id           int64           `json:"id"`
	Name         string          `json:"name"`
	Cover        string          `json:"cover"`
	IsPublic     bool            `json:"isPublic"`
	Material     string          `json:"material"`
	MaterialList TemplateMateria `json:"materialList"`
}

type ProductTemplate struct {
	CoverImg     string       `json:"cover_img"`
	Id           int64        `json:"id"`
	IsPublic     bool         `json:"is_public"`
	LogoHeight   int64        `json:"logo_height"`
	LogoWidth    int64        `json:"logo_width"`
	MaterialImg  string       `json:"material_img"`
	ModelId      int64        `json:"model_id"`
	Name         string       `json:"name"`
	ProductId    int64        `json:"product_id"`
	Sort         int64        `json:"sort"`
	Tag          Tag          `json:"tag"`
	TemplateInfo TemplateInfo `json:"template_info"`
	Title        string       `json:"title"`
}

type Light struct {
	Id   int64     `json:"id"`
	Info LightInfo `json:"info"`
}

type TemplateMateria struct {
	Id            string          `json:"id"`
	Tag           string          `json:"tag"`
	Title         string          `json:"title"`
	Type          string          `json:"type"`
	Text          string          `json:"text"`
	Fill          string          `json:"fill"`
	FontSize      int64           `json:"fontSize"`
	FontFamily    string          `json:"fontFamily"`
	IfBr          bool            `json:"ifBr"`
	IfShow        bool            `json:"ifShow"`
	IfGroup       bool            `json:"ifGroup"`
	MaxNum        int64           `json:"maxNum"`
	Rotation      int64           `json:"rotation"`
	LineHeight    int64           `json:"lineHeight"`
	Align         string          `json:"align"`
	VerticalAlign string          `json:"verticalAlign"`
	Material      string          `json:"material"`
	MaterialTime  string          `json:"materialTime"`
	MaterialName  string          `json:"materialName"`
	QRcodeType    string          `json:"QRcodeType"`
	Width         int64           `json:"width"`
	Height        int64           `json:"height"`
	Proportion    int64           `json:"proportion"`
	X             int64           `json:"x"`
	Y             int64           `json:"y"`
	Opacity       int64           `json:"opacity"`
	OptionalColor []OptionalColor `json:"optionalColor"`
	ZIndex        int64           `json:"zIndex"`
	SvgPath       string          `json:"svgPath"`
	Follow        Follow          `json:"follow"`
	Group         []interface{}   `json:"group"`
	CameraStand   CameraStand     `json:"cameraStand"`
}

type LightInfo struct {
	Name      string          `json:"name"`
	Hdr       Hdr             `json:"hdr"`
	LightData []LightDataItem `json:"lightData"`
}

type LightDataItem struct {
	Color      string  `json:"color"`
	Id         string  `json:"id"`
	Intensity  float64 `json:"intensity"`
	Name       string  `json:"name"`
	Type       string  `json:"type"`
	X          float64 `json:"x,omitempty"`
	Y          int64   `json:"y,omitempty"`
	Z          float64 `json:"z,omitempty"`
	ShowHelper bool    `json:"showHelper,omitempty"`
	Width      int64   `json:"width,omitempty"`
	Height     int64   `json:"height,omitempty"`
	Rx         int64   `json:"rx,omitempty"`
	Ry         int64   `json:"ry,omitempty"`
	Rz         int64   `json:"rz,omitempty"`
}

type Hdr struct {
	IfBg                bool    `json:"ifBg"`
	ToneMappingExposure float64 `json:"toneMappingExposure"`
	Url                 string  `json:"url"`
}

type OptionalColor struct {
	Color   string `json:"color"`
	Name    string `json:"name"`
	Default bool   `json:"default"`
}

type Follow struct {
	Fill    string `json:"fill"`
	IfShow  string `json:"ifShow"`
	Content string `json:"content"`
}

type CameraStand struct {
	X int64 `json:"x"`
	Y int64 `json:"y"`
	Z int64 `json:"z"`
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type ResponseJwt struct {
	Code         int         `json:"code"`
	Message      string      `json:"msg"`
	Data         interface{} `json:"data"`
	AccessSecret string      `json:"accessSecret"`
	AccessExpire int64       `json:"accessExpire"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
